package n7.facade;

import java.util.Collection;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class Facade {

    @Autowired
    PersonneRepository pr;
    @Autowired
    AdresseRepository ar;

    @GetMapping("/ajoutpersonne")
    public void ajoutPersonne(
        @RequestParam("nom") String nom, 
        @RequestParam("prenom") String prenom) {
		Personne p = new Personne();
		p.setNom(nom);
		p.setPrenom(prenom);
        pr.save(p);
	}
	
    @GetMapping("/ajoutadresse")
	public void ajoutAdresse(
        @RequestParam("rue") String rue, 
        @RequestParam("ville") String ville) {
		Adresse a = new Adresse();
		a.setRue(rue);
		a.setVille(ville);
        ar.save(a);
	}

    @GetMapping("/listepersonnes")
	public Collection<Personne> listePersonnes() {
		return pr.findAll();
	}

	@GetMapping("/listeadresses")
	public Collection<Adresse> listeAdresses() {
		return ar.findAll();
	}
	
    @PostMapping("/associer")
	public void associer(
        @RequestParam("pid") Long personneId, 
        @RequestParam("aid") Long adresseId) {
        Optional<Personne> personne = pr.findById(personneId);
        Optional<Adresse> adresse = ar.findById(adresseId);
        if ((personne.isPresent()) && (adresse.isPresent())) {
            Adresse a = adresse.get();
            Personne p = personne.get();
            a.setLocataire(p);
            ar.save(a);
        }
	}
}
